// wii_sequence.js : store and handle the wii sequencing tasks
// ----------------------------------------------------------------------------

inlets = 2;
outlets = 3;

var i;

var c_notes = new Array();
for (i=0; i<32; i++) {
	c_notes[i] = 0;
}

var c_step = 0;
var c_dir = 1;
var c_trans = 0;
var c_start = 0;
var c_end = 31;
var c_dur = 250;

var c_lval = -1;
var c_auto = 0;
var c_vel = 100;

seq_sendstatus();

function notes()
{
	var a = arrayfromargs(arguments);
	for (i=0; i<a.length; i++) {
		c_notes[i] = a[i];
	}
}

function duration(dur)
{
	c_dur = dur;
	if (c_dur < 10)	c_dur = 10;
	if (c_dur > 10000)	c_dur = 10000;
}

function bang()
{
	if (c_auto == 1) {
		seq_step();
		tsk = new Task(seq_noteoff, this, c_lval);
		tsk.schedule(c_dur);
	}
}

function mtn()
{
	var a = arrayfromargs(arguments);
	c_vel = Math.floor((a[0] - 100) * 2.5);
	if (c_vel <= 0)	c_vel = 5;
	if (c_vel > 125)	c_vel = 125;
}

function btn()
{
	var a = arrayfromargs(arguments);
	if (a.length == 2) {
		if ((a[0] == 1) && (a[1] == 1)) {
			c_start = c_step;
			seq_sendstatus();
		}
		if ((a[0] == 2) && (a[1] == 1)) {
			c_end = c_step;
			seq_sendstatus();
		}
		if ((a[0] == "A") && (a[1] == 1)) {
			if (c_auto == 0) {
				c_auto = 1;
				seq_noteoff(c_lval);
				c_lvl = -1;
			} else {
				c_auto = 0;
				seq_noteoff(c_lval);
				c_lvl = -1;
			}
		}
		else if ((a[0] == "B") && (a[1] == 1)) {
			seq_step();
		}
		else if ((a[0] == "B") && (a[1] == 0)) {
			seq_noteoff(c_lval);
			c_lvl = -1;
		}
		else if ((a[0] == "minus") && (a[1] == 1)) {
			c_dir = -1;
			seq_sendstatus();
		}
		else if ((a[0] == "plus") && (a[1] == 1)) {
			c_dir = 1;
			seq_sendstatus();
		}
		else if ((a[0] == "up") && (a[1] == 1)) {
			c_trans += 1;
			seq_sendstatus();
		}
		else if ((a[0] == "down") && (a[1] == 1)) {
			c_trans -= 1;
			seq_sendstatus();
		}
		else if ((a[0] == "left") && (a[1] == 1)) {
			c_step -= 1;
			if (c_step < 0)	c_step = 31;
			if (c_step > 31)	c_step = 0;
			seq_sendstatus();
		}
		else if ((a[0] == "right") && (a[1] == 1)) {
			c_step += 1;
			if (c_step < 0)	c_step = 31;
			if (c_step > 31)	c_step = 0;
			seq_sendstatus();
		}
		else if ((a[0] == "home") && (a[1] == 1)) {
			c_step = -1;
			c_start = 0;
			c_end = 31;
			seq_sendstatus();
		}
	}
}

seq_step.local = 1;
function seq_step()
{
	if (c_lval < 0) {
		seq_noteoff(c_lval);
		c_lval = -1;
	}

	c_step += c_dir;

	if (c_step > c_end) {
		c_step = c_start;
	}
	if (c_step < c_start) {
		c_step = c_end;
	}

	c_lval = c_notes[c_step] + c_trans;
	if (c_lval < 0) {
		c_lval = 0;
	}
	if (c_lval > 127) {
		c_lval = 127;
	}

	seq_sendstatus();
	outlet(1, c_vel);
	outlet(0,c_lval);
}

seq_noteoff.local = 1;
function seq_noteoff(note)
{
	seq_sendstatus();
	outlet(1, 0);
	outlet(0, note);
}

seq_sendstatus.local = 1;
function seq_sendstatus()
{
	outlet(2, "list", c_step, c_dir, c_trans, c_auto, c_start, c_end);
	
}